<template>
  <div>
    <h3 class="line-header">
      <img
        src="@/assets/icons/form_description_file.svg"
        alt="Icône fichier"
      > Fiche donnée
    </h3>

    <!-- NOM -->
    <div class="form-row">
      <div class="form-group col-12">
        <label class="required">Nom du jeu de donnée</label>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Nom"
          rules="required"
        >
          <input
            v-model="form.display_name"
            class="control form-control"
            :class="classes"
            type="text"
            placeholder="Nom"
            maxlength="254"
          >
          <span class="form-errors">{{ errors[0] }}</span>
        </ValidationProvider>
      </div>
    </div>

    <!-- THUMBNAIL -->
    <div class="form-row">
      <div class="form-group col-8">
        <label>Vignette d'illustration</label>
        <p>Importer une image au format JPG ou PNG (taille maximale: 2Mo)</p>
        <ImportImage
          :type="'image'"
          :name="'dataset-thumbnail'"
          :title="form.thumbnail ? form.thumbnail.name : null"
          :file="form.thumbnail ? form.thumbnail.url : null"
          @update="setThumbnail"
        />
      </div>
    </div>

    <!-- DESCRIPTION -->
    <div class="form-row">
      <div class="form-group col-12">
        <label class="required">Description du jeu de données</label>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Description"
          rules="required"
        >
          <textarea
            v-model="form.description"
            :class="classes"
            class="control form-control"
          />
          <span class="form-errors">{{ errors[0] }}</span>
        </ValidationProvider>
      </div>
    </div>

    <!-- MOT CLES -->
    <div class="form-row">
      <div class="form-group col-12">
        <label class="required">Mots-clés</label>
        <p>Inscrire des mots-clés pour retrouver les données via la barre de recherche.</p>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Mot-clés"
          rules="required"
        >
          <Keywords
            v-model="isKeywordsValid"
            :tags="form.keywords"
            :classes="classes"
            @update="updateKeywords"
          />
          <span class="form-errors">{{ errors[0] }}</span>
        </ValidationProvider>
      </div>
    </div>

    <!-- CATEGORIES -->
    <div class="form-row">
      <div class="form-group col-12">
        <label>Catégories {{ clientName }}</label>
        <p>Choisir la(les) catégorie(s) dans laquelle(lesquelles) apparaitront les données.</p>
        <Categories
          :categories="datasetsCategories.map(el => el.display_name)"
          :dataset-categories="form.categories"
          @update="updateCategories"
        />
      </div>
    </div>

    <!-- THEMATIQUES -->
    <div class="form-row">
      <div class="form-group col-12">
        <label class="required">Thématiques</label>
        <p>Choisir la(les) thématique(s) dans laquelle(lesquelles) apparaitront les données.</p>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Thématiques"
          rules="required"
        >
          <Categories
            v-model="isTopicsValid"
            :categories="datasetsTopics.map(el => el.display_name)"
            :dataset-categories="form.topics"
            :classes="classes"
            @update="updateTopics"
          />
          <span class="form-errors">{{ errors[0] }}</span>
        </ValidationProvider>
      </div>
    </div>

    <!-- TYPES DE DONNEES -->
    <div class="form-row">
      <div class="form-group col-12">
        <label class="required">Types de données</label>
        <p>Choisir le(les) type(s) de données.</p>
        <ValidationProvider
          v-slot="{ classes, errors }"
          name="Types de données"
          rules="required"
        >
          <Kinds
            v-model="isKindsValid"
            :kinds="form.kinds"
            :classes="classes"
            @update="updateKinds"
          />
          <span class="form-errors">{{ errors[0] }}</span>
        </ValidationProvider>
      </div>
    </div>

    <!-- PRECONISATION -->
    <div class="form-row">
      <div class="form-group col-12">
        <label>Préconisation d'usage</label>
        <textarea
          v-model="form.recommendation"
          class="form-control"
        />
      </div>
    </div>

    <!-- LIMITE D'UTILISATION -->
    <div class="form-row">
      <div class="form-group col-12">
        <label>Limite d'utilisation</label>
        <Multiselect
          v-model="form.restriction"
          :options="datasetsRestrictions"
          select-label=""
          selected-label=""
          deselect-label=""
          :searchable="true"
          :preserve-search="true"
          :show-no-results="false"
          placeholder="Sélectionner une option ou saisir la limite d'utilisation ..."
          @select="setRestriction"
          @search-change="setRestriction"
        />
      </div>
    </div>

    <h3 class="line-header">
      <img
        src="@/assets/icons/company.svg"
        alt="Icône organisation"
      > Organisation / Groupes d'utilisateurs
    </h3>

    <!-- ORGANISATION -->
    <div class="form-row">
      <div class="form-group col-12">
        <label
          class="required"
          style="margin-top: 1em;"
        >
          Nom de l'organisation ou du groupe d'utilisateurs
        </label>
        <p>Rechercher un(e) organisation/groupe d'utilisateurs dans la barre de recherche ci-dessous</p>
        <ValidationProvider
          v-slot="{ classes, errors }"
          rules="required"
          name="Organisation"
        >
          <div
            class="control"
            :class="classes"
          >
            <SearchUsergroups
              v-model="form.usergroup"
              :types="['organisation', 'user-group']"
              :placeholder="'Rechercher un groupe ou une organisation ...'"
              :usergroup="form.usergroup"
              :disabled="mode === 'datasetDetail'"
              :reset-after="false"
              :limit="100"
              @select="setOrganisation"
              @close="setOrganisation"
            />
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
    </div>

    <h3 class="line-header">
      <img
        src="@/assets/icons/user-group.svg"
        alt="Icône organisation"
      > Contacts
    </h3>

    <!-- CONTACTS -->
    <div class="form-row">
      <div class="form-group col-12">
        <p>Sélectionner une organisation pour activer l'ajout de contacts.</p>
        <!-- <ValidationProvider
          v-slot="{ classes, errors }"
          rules="required"
          name="Organisation"
        > -->
          <DatasetContactForm
            v-for="contact in form.datasetContacts"
            :key="contact.id"
            :contact="contact"
            @allowAdd="setCanAddContact"
            @change="updateContact"
            @delete="removeContact"
          />
          <!-- <span class="form-errors">{{ errors[0] }}</span>
        </ValidationProvider> -->
      </div>
    </div>
    <button
      class="add-button"
      :class="{
        disabled: form.usergroup === null || !canAddContact
      }"
      @click.prevent="addContact"
    >
      <b-icon-plus />
      Ajouter un contact
    </button>

    <h3 class="line-header">
      <img
        src="@/assets/icons/license_privacy_security.svg"
        alt="Icône licence"
      > Licence
    </h3>

    <!-- LICENCE -->
    <div class="form-row">
      <div class="form-group col-12">
        <label style="margin-top: 1em;">Licence</label>
        <Multiselect
          v-model="form.licence"
          :options="datasetsLicences"
          track-by="codename"
          label="display_name"
          select-label=""
          selected-label=""
          deselect-label=""
          :searchable="false"
          placeholder="Licence"
        />
      </div>
    </div>

    <!-- COPYRIGHT -->
    <div class="form-row">
      <div class="form-group col-12">
        <label style="margin-top: 1em;">Copyright</label>
        <textarea
          v-model="form.copyright"
          class="form-control"
          type="text"
          rows="3"
          placeholder="Copyright"
        />
      </div>
    </div>

    <h3 class="line-header">
      <img
        src="@/assets/icons/territory_map_cadastre.svg"
        alt="Icône licence"
      > Couverture géographique et granularité
    </h3>

    <!-- GRANULARITE -->
    <div class="form-row">
      <div class="form-group col-12">
        <label style="margin-top: 1em;">
          Granularité de la couverture géographique
        </label>
        <Multiselect
          v-model="form.granularity"
          :options="datasetsGranularities"
          track-by="codename"
          label="display_name"
          select-label=""
          selected-label=""
          deselect-label=""
          :searchable="false"
          placeholder="Granularité de la couverture géographique"
        />
      </div>
    </div>

    <!-- COUVERTURE GEOGRAPHIQUE -->
    <div class="form-row">
      <div class="form-group col-12">
        <label style="margin-top: 1em;">
          Couverture géographique
        </label>
        <Multiselect
          v-model="form.coverage"
          :options="coverageOptions"
          track-by="code"
          label="label"
          select-label=""
          selected-label=""
          deselect-label=""
          :searchable="false"
          placeholder="Définie automatiquement"
        />
      </div>
    </div>

    <h3 class="line-header">
      <img
        src="@/assets/icons/calendar_date.svg"
        alt="Icône calendrier"
      > Dates et mises à jour
    </h3>

    <!-- DATES -->
    <div class="form-row">
      <div
        v-if="form.creationDate"
        class="form-group col-4"
      >
        <label
          class="required"
          style="margin-top: 1em;"
        >
          Date de création
        </label>
        <div
          readonly
          class="form-control"
        >
          {{ new Date(form.creationDate).toLocaleString() }}
        </div>
      </div>
      <div
        v-if="form.revisionDate"
        class="form-group col-4"
      >
        <label
          class="required"
          style="margin-top: 1em;"
        >
          Date de dernière révision
        </label>
        <div
          readonly
          class="form-control"
        >
          {{ new Date(form.revisionDate).toLocaleString() }}
        </div>
      </div>
    </div>
    <div class="form-row">
      <div class="form-group col-4">
        <label class="required" style="margin-top: 1em;">
          Date de publication
        </label>
        <ValidationProvider
          v-slot="{ classes, errors }"
          rules="required"
          name="Date de publication"
        >
          <div
            class="control"
            :class="classes"
          >
            <input
              v-model="form.publicationDate"
              class="form-control"
              type="date"
            >
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
      <div class="form-group col-4">
        <label class="required" style="margin-top: 1em;">
          Date de dernière mise à jour
        </label>
        <ValidationProvider
          v-slot="{ classes, errors }"
          rules="required"
          name="Date de dernière mise à jour"
        >
          <div
            class="control"
            :class="classes"
          >
            <input
              v-model="form.lastUpdateDate"
              class="form-control"
              type="date"
            >
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
    </div>

    <!-- FREQUENCE -->
    <div class="form-row">
      <div class="form-group col-6">
        <label
          class="required"
          style="margin-top: 1em;"
        >
          Fréquence de mise à jour
        </label>
        <p>La fréquence de mise à jour sera indiquée aux autres utilisateurs.</p>
        <ValidationProvider
          v-slot="{ classes, errors }"
          rules="required"
          name="Fréquence"
        >
          <div
            class="control"
            :class="classes"
          >
            <Multiselect
              v-model="form.frequence"
              :options="datasetsUpdateFrequencies"
              track-by="value"
              label="label"
              select-label=""
              selected-label=""
              deselect-label=""
              :searchable="false"
              placeholder="Fréquence"
            />
            <span class="form-errors">{{ errors[0] }}</span>
          </div>
        </ValidationProvider>
      </div>
      <div class="form-group col-1" />
      <div class="form-group col-2">
        <label style="margin-top: 1em;">Millésime</label>
        <p>Sélectionner une année</p>
        <input
          v-model="form.year"
          class="form-control"
          style="height: 3.1em;"
          placeholder="Année"
          type="number"
          :min="1900"
          :max="new Date().getFullYear()"
          step="1"
        >
      </div>
    </div>

    <!-- MODE DE CONSTITUTION -->
    <div class="form-row">
      <div class="form-group col">
        <label style="margin-top: 1em;">Mode de constitution</label>
        <textarea
          v-model="form.lineage"
          class="form-control"
        />
      </div>
    </div>
  </div>
</template>

<script>
import ImportImage from '@/components/ImportImage.vue';
import Keywords from '@/components/Keywords.vue';
import Categories from '@/components/Categories.vue';
import Kinds from '@/components/Kinds.vue';
import DatasetContactForm from '@/components/Forms/DatasetContactForm.vue';
import SearchUsergroups from '@/components/SearchUsergroups.vue';
import Multiselect from 'vue-multiselect';

import { mapState, mapMutations, mapActions } from 'vuex';

import { ValidationProvider, extend, configure, setInteractionMode } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});
setInteractionMode('passive');

export default {
  name: 'DatasetForm',

  components: {
    ImportImage,
    Keywords,
    Categories,
    Kinds,
    DatasetContactForm,
    SearchUsergroups,
    Multiselect,
    ValidationProvider
  },

  props: {
    mode: {
      type: String,
      default: 'datasetDetail'
    },
    defaultForm: {
      type: Object,
      default: () => {
        return {
          display_name: null,
          description: null,
          keywords: [],
          categories: [],
          topics: [],
          kinds: [],
          recommendation: null,
          restriction: null,
          usergroup: null,
          datasetContacts: [],
          licence: null,
          copyright: null,
          granularity: null,
          coverage: null,
          frequence: null,
          publicationDate: null,
          lastUpdateDate: null,
          creationDate: null,
          revisionDate: null,
          year: null,
          lineage: null,
          resource: null,
          annexe: null,
          thumbnail: null
        };
      }
    }
  },

  data() {
    return {
      form: {},
      coverageOptions: [
        { label: 'Région', code: 0 },
        { label: 'Territoire de compétence de l\'organisation', code: 1 },
        { label: 'Calculée sur la donnée', code: 2 }
      ],
      canAddContact: true,
      isKeywordsValid: null,
      isTopicsValid: null,
      isKindsValid: null
    };
  },

  computed: {
    ...mapState('user', [
      'userData'
    ]),
    ...mapState('form', [
      'currentFormId',
      'currentForm'
    ]),
    ...mapState('user-login', [
      'userData'
    ]),
    ...mapState('datasets', [
      'datasetsCategories',
      'datasetsGranularities',
      'datasetsLicences',
      'datasetsTopics',
      'datasetsKinds',
      'datasetsRestrictions',
      'datasetsUpdateFrequencies',
      'lastCreatedDataset'
    ]),
    ...mapState('resources', [
      'resourceInspectionData',
      'currentResourceFileId'
    ]),

    clientName() {
      return process.env.VUE_APP_CLIENT_NAME;
    }
  },

  watch: {
    form: {
      deep: true,
      handler(newValue) {
        this.SET_CURRENT_FORM({
          id: this.mode,
          form: newValue
        });
        this.$emit('change', this.form);
      }
    },

    'form.resource.file': function(newValue, oldValue) {
      if (newValue !== oldValue) {
        this.SET_CURRENT_RESOURCE_FILE_ID(null);
      }
    },
  },

  created() {
    this.getConfigData();
    if (this.defaultForm) {
      this.form = this.defaultForm;
      if (this.form.usergroup && this.form.datasetContacts.length === 0) {
        this.addContact();
      }
      if (this.form.keywords.length > 0) {
        this.isKeywordsValid = true;
      } else {
        this.isKeywordsValid = null;
      }
    }
    if (this.currentFormId === this.mode) {
      this.form = {
        ...this.form,
        ...this.currentForm,
      };
      this.form.resource = null;
      this.SET_CURRENT_RESOURCE_FILE_ID(null);
    }
  },

  methods: {
    ...mapMutations('form', [
      'SET_CURRENT_FORM'
    ]),
    ...mapMutations('resources', [
      'SET_CURRENT_RESOURCE_FILE_ID'
    ]),
    ...mapActions('datasets', [
      'GET_DATASETS_CATEGORIES',
      'GET_DATASETS_GRANULARITIES',
      'GET_DATASETS_LICENCES',
      'GET_DATASETS_TOPICS',
      'GET_DATASETS_KINDS',
      'GET_DATASETS_RESTRICTIONS',
      'GET_DATASETS_UPDATE_FREQUENCIES'
    ]),

    getConfigData() {
      if (this.datasetsCategories.length === 0) {
        this.GET_DATASETS_CATEGORIES();
      }
      if (this.datasetsGranularities.length === 0) {
        this.GET_DATASETS_GRANULARITIES();
      }
      if (this.datasetsLicences.length === 0) {
        this.GET_DATASETS_LICENCES();
      }
      if (this.datasetsTopics.length === 0) {
        this.GET_DATASETS_TOPICS();
      }
      if (this.datasetsKinds.length === 0) {
        this.GET_DATASETS_KINDS();
      }
      if (this.datasetsRestrictions.length === 0) {
        this.GET_DATASETS_RESTRICTIONS();
      }
      if (this.datasetsUpdateFrequencies.length === 0) {
        this.GET_DATASETS_UPDATE_FREQUENCIES();
      }
    },

    setThumbnail(e) {
      const formData = new FormData();
      formData.append('file', e);
      this.form.thumbnail = formData;
    },
    setRestriction(e) {
      this.form.restriction = e;
    },

    setOrganisation(e) {
      this.form.usergroup = e;
      if (this.form.usergroup && this.form.datasetContacts.length === 0) {
        this.addContact();
      } else if (!this.form.usergroup) {
        this.form.datasetContacts = [];
        this.canAddContact = false;
      }
    },

    updateCategories(e) {
      this.form.categories = e;
    },

    updateTopics(e) {
      this.form.topics = e;
      if (this.form.topics.length > 0) {
        this.isTopicsValid = true;
      } else {
        this.isTopicsValid = null;
      }
    },

    updateKinds(e) {
      this.form.kinds = e;
      if (this.form.kinds.length > 0) {
        this.isKindsValid = true;
      } else {
        this.isKindsValid = null;
      }
    },

    updateKeywords(e) {
      this.form.keywords = e;
      if (this.form.keywords.length > 0) {
        this.isKeywordsValid = true;
      } else {
        this.isKeywordsValid = null;
      }
    },

    setCanAddContact(e) {
      this.canAddContact = e;
    },

    addContact() {
      const position = this.form.datasetContacts.length + 1;
      this.form.datasetContacts.push({
        position: position,
        email: null,
        name: '',
        role: 0,
        usergroup: this.form.usergroup.id
      });
      this.canAddContact = false;
    },

    updateContact(e) {
      const index = this.form.datasetContacts.findIndex(el => el.position === e.position);
      this.form.datasetContacts[index] = {
        ...e.id && { id: e.id },
        position: e.position,
        email: e.email,
        name: e.name,
        role: e.role,
        usergroup: e.usergroup
      };
    },

    removeContact(e) {
      const index = e - 1;
      this.form.datasetContacts.splice(index, 1);
      if (
        this.form.datasetContacts.length === 0 ||
        (
          this.form.datasetContacts[this.form.datasetContacts.length - 1].name !== null &&
          this.form.datasetContacts[this.form.datasetContacts.length - 1].email !== null
        )
      ) {
        this.canAddContact = true;
      }
    }
  }
};
</script>
